// this requires T to be defined!!!

template class MT::Array<T>;

template MT::Array<T> MT::operator~(const Array<T>& y);
template MT::Array<T> MT::operator-(const Array<T>& y);
template MT::Array<T> MT::operator-(const Array<T>& y,const Array<T>& z);
template MT::Array<T> MT::operator*(const Array<T>& y,const Array<T>& z);
template MT::Array<T> MT::operator/(const Array<T>& y,const Array<T>& z);
template MT::Array<T> MT::operator^(const Array<T>& y,const Array<T>& z);
template MT::Array<T> MT::operator%(const Array<T>& y,const Array<T>& z);
template MT::Array<T> MT::operator*(T,const Array<T>& z);
template MT::Array<T> MT::operator-(T,const Array<T>& z);
template MT::Array<T> MT::operator-(const Array<T>& z,T);
template MT::Array<T> MT::operator*(const Array<T>& z,T);
template MT::Array<T> MT::operator/(const Array<T>& z,T);
template MT::Array<T> MT::operator+(const Array<T>& y,const Array<T>& z);
template MT::Array<T> MT::operator+(T,const Array<T>& z);
template MT::Array<T>& MT::operator+=(Array<T>& y,T);
template bool operator==(const MT::Array<T>& v,const MT::Array<T>& w);
template bool operator==(const MT::Array<T>& v,const T *w);
template std::istream& operator>>(std::istream& is,MT::Array<T>& x);

template MT::Array<T> exp(const MT::Array<T>&);

template void transpose(MT::Array<T>& x,const MT::Array<T>& y);

template T entropy(const MT::Array<T>& v);
template T normalizeDist(MT::Array<T>& v);
template void makeConditional(MT::Array<T>& P);
template void checkNormalization(MT::Array<T>& v,double tol);
template void eliminate(MT::Array<T>& x,const MT::Array<T>& y,uint d);
template void eliminate(MT::Array<T>& x,const MT::Array<T>& y,uint d,uint e);
template void eliminatePartial(MT::Array<T>& x,const MT::Array<T>& y,uint d);

template T sqrDistance(const MT::Array<T>& v, const MT::Array<T>& w);
template T maxDiff(const MT::Array<T>& v,const MT::Array<T>& w,uint *im);
template T maxRelDiff(const MT::Array<T>& v,const MT::Array<T>& w,T tol);
//template T sqrDistance(const MT::Array<T>& v, const MT::Array<T>& w,const MT::Array<bool>& mask);
template T sqrDistance(const MT::Array<T>& g,const MT::Array<T>& v,const MT::Array<T>& w);
template T euclideanDistance(const MT::Array<T>& v, const MT::Array<T>& w);
template T metricDistance(const MT::Array<T>& g,const MT::Array<T>& v, const MT::Array<T>& w);

template T sum(const MT::Array<T>& v);
template T sumOfAbs(const MT::Array<T>& v);
template T sumOfSqr(const MT::Array<T>& v);
template T norm(const MT::Array<T>& v);
template T mean(const MT::Array<T>& v);

template T var(const MT::Array<T>& v);
template T trace(const MT::Array<T>& v);

template T minDiag(const MT::Array<T>& v);

template T product(const MT::Array<T>& v);
template void innerProduct(MT::Array<T>& x,const MT::Array<T>& y, const MT::Array<T>& z);
template void outerProduct(MT::Array<T>& x,const MT::Array<T>& y, const MT::Array<T>& z);
template T scalarProduct(const MT::Array<T>& v, const MT::Array<T>& w);
template T scalarProduct(const MT::Array<T>& g,const MT::Array<T>& v, const MT::Array<T>& w);


template void tensorMarginal(MT::Array<T> &Y,const MT::Array<T> &X,const MT::Array<uint> &Yid);
template void tensorMaxMarginal(MT::Array<T> &Y,const MT::Array<T> &X,const MT::Array<uint> &Yid);
template void tensorMarginal_old(MT::Array<T> &y,const MT::Array<T> &x,const MT::Array<uint> &xd,const MT::Array<uint> &ids);
template void tensorMultiply(MT::Array<T> &X,const MT::Array<T> &Y,const MT::Array<uint> &Yid);
template void tensorMultiply_old(MT::Array<T> &x,const MT::Array<T> &y,const MT::Array<uint> &d,const MT::Array<uint> &ids);

//template void section(MT::Array<T>& x,const MT::Array<T>& y, const MT::Array<T>& z);
template void rndInt(MT::Array<T>& a,int low,int high,bool add);
template void rndUni(MT::Array<T>& a,double low,double high,bool add);
template void rndGauss(MT::Array<T>& a,double stdDev,bool add);
//template void rndGauss(MT::Array<T>& a,bool add);
//template MT::Array<T>& rndGauss(double stdDev,uint dim);
template uint softMax(const MT::Array<T>& a,MT::Array<double>& soft,double beta);

template void writeArr(const MT::Array<T>& x,const char* tag,std::ofstream& os);
template bool readArr(MT::Array<T>& x,const char *tag,std::ifstream& is);

#undef T
